"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var core_1 = require('@angular/core');
var core_2 = require('@ngx-translate/core');
var core_service_1 = require('ng2-catalogic/core/service/core.service');
var actions_service_1 = require('../services/actions.service');
var emi_service_1 = require('../../emi.service');
var ActionsComponent = (function () {
    function ActionsComponent(coreService, actionsService, emiService, translate) {
        var _this = this;
        this.coreService = coreService;
        this.actionsService = actionsService;
        this.emiService = emiService;
        this.translate = translate;
        this.stepversionfontcolor = "grey";
        this.productRunning = false;
        this.somethingIsRunning = false;
        this.actionsCmdStartappInitialize = true;
        this.actionsCmdStartappRunning = false;
        this.actionsCmdStartappSuccess = false;
        this.actionsCmdStopappInitialize = true;
        this.actionsCmdStopappRunning = false;
        this.actionsCmdStopappSuccess = false;
        this.actionsCmdRestartappInitialize = true;
        this.actionsCmdRestartappRunning = false;
        this.actionsCmdRestartappSuccess = false;
        this.actionsCmdAppstatusRunning = false;
        this.actionsCmdAppstatusSuccess = false;
        this.actionsCmdRestartInitialize = true;
        this.actionsCmdRestartRunning = false;
        this.actionsCmdRestartSuccess = false;
        this.manageAppSubscriptionErrors = false;
        this.sessionTimeoutException = false;
        this.showChangeTimezone = false;
        this.showCurrentTimezone = false;
        this.showTimezoneUpdateSuccess = false;
        this.updatingTimezone = false;
        this.productName = this.getProductName();
        translate.get('ACTIONS.TIMEZONE_DROPDOWN_DEFAULT_LABEL').subscribe(function (res) {
            _this.dropdownlabel = res;
        });
    }
    ActionsComponent.prototype.ngOnInit = function () {
        if (this.emiService.getSessionTimeOutStatus()) {
            this.sessionTimeoutException = true;
            this.manageAppSubscriptionErrors = true;
        }
        else {
            this.manageApp("appstatus");
            this.getTimezones();
        }
    };
    ActionsComponent.prototype.getProductName = function () {
        return this.emiService.getProductName();
    };
    ActionsComponent.prototype.getCompanyName = function () {
        return this.emiService.getCompanyName();
    };
    ActionsComponent.prototype.getTimezones = function () {
        var _this = this;
        this.actionsService.getTimezones()
            .subscribe(function (timezones) {
            _this.dropdownvalues = timezones;
            _this.showChangeTimezone = true;
        }, function (error) {
            _this.errorMessage = error;
            console.error('ActionsComponent ==> getTimezones() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.manageAppSubscriptionErrors = true;
        });
    };
    ActionsComponent.prototype.onSelect = function (value) {
        var _this = this;
        console.log('ActionsComponent ==> onSelect() ==> ' + value);
        this.dropdownlabel = value;
        this.updatingTimezone = true;
        this.actionsService.changeTimezone(value)
            .subscribe(function (commandoutput) {
            _this.updatingTimezone = false;
            _this.errorCode = commandoutput.errorCode;
            if (_this.errorCode === "0") {
                _this.showTimezoneUpdateSuccess = true;
            }
        }, function (error) {
            _this.updatingTimezone = false;
            _this.errorMessage = error;
            console.error('ActionsComponent ==> onSelect() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.manageAppSubscriptionErrors = true;
        });
    };
    ActionsComponent.prototype.getCurrentTimezone = function () {
        var _this = this;
        this.actionsService.getCurrentTimezone()
            .subscribe(function (commandoutput) {
            _this.errorCode = commandoutput.errorCode;
            if (_this.errorCode === "0") {
                _this.currentTimezone = commandoutput.commandOutput;
                _this.showCurrentTimezone = true;
            }
        }, function (error) {
            _this.errorMessage = error;
            console.error('ActionsComponent ==> getCurrentTimezone() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.manageAppSubscriptionErrors = true;
        });
    };
    ActionsComponent.prototype.reinitialize = function (mode) {
        console.log('ActionsComponent ==> reinitialize() ==> ' + mode);
        this.actionsReinitializeType = mode;
        if (this.actionsReinitializeType === "startapp") {
            this.actionsCmdStartappInitialize = true;
            this.actionsCmdStartappSuccess = false;
            this.productRunning = true;
        }
        else if (this.actionsReinitializeType === "stopapp") {
            this.actionsCmdStopappInitialize = true;
            this.actionsCmdStopappSuccess = false;
            this.productRunning = false;
        }
        else if (this.actionsReinitializeType === "restartapp") {
            this.actionsCmdRestartappInitialize = true;
            this.actionsCmdRestartappSuccess = false;
            this.productRunning = true;
        }
        else if (this.actionsReinitializeType === "restart") {
            this.actionsCmdRestartInitialize = true;
        }
    };
    ActionsComponent.prototype.manageApp = function (mode) {
        var _this = this;
        console.log('ActionsComponent ==> manageApp() ==> ' + mode);
        this.actionsType = mode;
        this.somethingIsRunning = true;
        this.coreService.setPluginStatus(this.emiService.getPluginName(), this.emiService.getNavigationStatusKey(), false);
        this.coreService.setPluginStatus(this.emiService.getPluginName(), this.emiService.getAdminconsoleNavigationStatusKey(), false);
        if (this.actionsType === "startapp") {
            this.actionsCmdStartappInitialize = false;
            this.actionsCmdStartappRunning = true;
        }
        else if (this.actionsType === "stopapp") {
            this.actionsCmdStopappInitialize = false;
            this.actionsCmdStopappRunning = true;
        }
        else if (this.actionsType === "restartapp") {
            this.actionsCmdRestartappInitialize = false;
            this.actionsCmdRestartappRunning = true;
        }
        else if (this.actionsType === "appstatus") {
            this.actionsCmdAppstatusRunning = true;
        }
        else if (this.actionsType === "restart") {
            this.actionsCmdRestartInitialize = false;
            this.actionsCmdRestartRunning = true;
        }
        this.actionsService.manageAppService(this.actionsType)
            .subscribe(function (commandoutput) {
            _this.errorCode = commandoutput.errorCode;
            if (_this.errorCode === "0") {
                if (_this.actionsType === "startapp") {
                    _this.actionsCmdStartappSuccess = true;
                    _this.actionsCmdStartappRunning = false;
                }
                else if (_this.actionsType === "stopapp") {
                    _this.actionsCmdStopappSuccess = true;
                    _this.actionsCmdStopappRunning = false;
                }
                else if (_this.actionsType === "restartapp") {
                    _this.actionsCmdRestartappSuccess = true;
                    _this.actionsCmdRestartappRunning = false;
                }
                else if (_this.actionsType === "appstatus") {
                    _this.productRunning = true;
                    _this.actionsCmdAppstatusSuccess = true;
                    _this.actionsCmdAppstatusRunning = false;
                }
                else if (_this.actionsType === "restart") {
                    _this.actionsCmdRestartSuccess = true;
                    _this.actionsCmdRestartRunning = false;
                }
            }
            _this.somethingIsRunning = false;
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
        }, function (error) {
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getNavigationStatusKey(), true);
            _this.coreService.setPluginStatus(_this.emiService.getPluginName(), _this.emiService.getAdminconsoleNavigationStatusKey(), true);
            _this.errorMessage = error;
            console.error('ActionsComponent ==> manageApp() ==> ' + _this.errorMessage);
            if (_this.errorMessage === _this.emiService.getSessionIdTimeoutError()) {
                _this.sessionTimeoutException = true;
                _this.emiService.setSessionTimedOut();
            }
            _this.manageAppSubscriptionErrors = true;
        });
    };
    __decorate([
        core_1.ViewChild('dropdown_tag'), 
        __metadata('design:type', Object)
    ], ActionsComponent.prototype, "dropDown", void 0);
    ActionsComponent = __decorate([
        core_1.Component({
            moduleId: module.id,
            selector: 'actions',
            templateUrl: '../views/actions.component.html'
        }), 
        __metadata('design:paramtypes', [core_service_1.CoreService, actions_service_1.ActionsService, emi_service_1.EMIService, core_2.TranslateService])
    ], ActionsComponent);
    return ActionsComponent;
}());
exports.ActionsComponent = ActionsComponent;
